--- asterisk-1.4.17/channels/chan_skinny.c	2007-12-18 17:42:41.000000000 -0500
+++ asterisk-1.4.17/channels/chan_skinny.c_AZ	2010-01-26 03:46:08.000000000 -0500
@@ -1418,11 +1418,24 @@
 
 static int skinny_unregister(struct skinny_req *req, struct skinnysession *s)
 {
+	struct skinny_subchannel *sub = NULL;
 	struct skinny_device *d;
+	struct skinny_line *l;
 
 	d = s->device;
 
 	if (d) {
+		sub = find_subchannel_by_instance_reference(d, d->lastlineinstance, d->lastcallreference);
+		if (sub) {			
+			if (sub->owner) {
+				sub->alreadygone = 1;
+				ast_queue_hangup(sub->owner);
+			} else {
+				l = sub->parent;
+				ast_log(LOG_WARNING, "arifzaman: Skinny(%s@%s-%d) channel already destroyed\n",
+					l->name, d->name, sub->callid);
+			}
+		}
 		d->session = NULL;
 		d->registered = 0;
 	}
